import { format, parse, isValid, eachDay, startOfWeek, lastDayOfWeek, startOfMonth, lastDayOfMonth, isBefore, isAfter, isWithinRange } from "date-fns";

export function parseDate(date, fmt) {
  var parsed = parse(date);

  if (!isValid(parsed) || format(parsed, fmt) !== date) {
    return null;
  }

  return parsed;
}

export function withinRange(date, _ref) {
  var start = _ref.start,
      end = _ref.end;

  if (start === null) {
    if (end === null) {
      return true;
    } else {
      return isBefore(date, end);
    }
  } else {
    if (end === null) {
      return isAfter(date, start);
    } else {
      return isWithinRange(date, start, end);
    }
  }
}

export function daysOfMonth(date) {
  return eachDay(startOfWeek(startOfMonth(date)), lastDayOfWeek(lastDayOfMonth(date)));
}