"use strict";

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp2;

var _react = require("react");

var _dateFns = require("date-fns");

var _utils = require("./utils");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// accessibility
// locale

var SaveTheDate = (_temp2 = _class = function (_Component) {
  _inherits(SaveTheDate, _Component);

  function SaveTheDate() {
    var _temp, _this, _ret;

    _classCallCheck(this, SaveTheDate);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = { editing: null }, _this.onChange = function (date) {
      if ((0, _utils.withinRange)(date, _this.props.range)) {
        _this.props.onChange(date);
      }
    }, _this.setEditing = function (date) {
      _this.setState({
        editing: {
          inputValue: _this.format(date),
          calendarValue: date,
          viewportDate: (0, _dateFns.startOfMonth)(date)
        }
      });
    }, _this.open = function () {
      return _this.setEditing(_this.props.value);
    }, _this.close = function () {
      if (_this.state.editing) {
        var _calendarValue = _this.state.editing.calendarValue;

        _this.setState({ editing: null }, function () {
          return _this.onChange(_calendarValue);
        });
      }
    }, _this.handleInput = function (e) {
      if (_this.state.editing) {
        var date = _this.parse(e.target.value);
        if (date !== null) {
          _this.setEditing(date);
        } else {
          _this.setState({
            editing: _extends({}, _this.state.editing, { inputValue: e.target.value })
          });
        }
      }
    }, _this.onSelect = function (date) {
      return _this.setEditing(date);
    }, _this.handleIncMonth = function () {
      if (_this.state.editing) {
        _this.setState({
          editing: _extends({}, _this.state.editing, {
            viewportDate: (0, _dateFns.addMonths)(_this.state.editing.viewportDate, 1)
          })
        });
      }
    }, _this.handleDecMonth = function () {
      if (_this.state.editing) {
        _this.setState({
          editing: _extends({}, _this.state.editing, {
            viewportDate: (0, _dateFns.subMonths)(_this.state.editing.viewportDate, 1)
          })
        });
      }
    }, _this.format = function (date) {
      return (0, _dateFns.format)(date, _this.props.format);
    }, _this.parse = function (string) {
      return (0, _utils.parseDate)(string, _this.props.format);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  SaveTheDate.prototype.render = function render() {
    var editing = this.state.editing;
    var _props = this.props,
        value = _props.value,
        render = _props.render;


    return render({
      inputProps: {
        onFocus: this.open,
        onBlur: this.close,
        value: editing ? editing.inputValue : this.format(value),
        onChange: this.handleInput
      },
      calendarProps: { onMouseDown: function onMouseDown(e) {
          return e.preventDefault();
        } },
      isOpen: Boolean(editing),
      open: this.open,
      close: this.close,
      selectedDate: editing && editing.calendarValue,
      onSelect: this.onSelect,
      viewportDate: editing && editing.viewportDate,
      onPrevMonth: this.handleDecMonth,
      onNextMonth: this.handleIncMonth
    });
  };

  return SaveTheDate;
}(_react.Component), _class.defaultProps = {
  range: { start: null, end: null },
  format: "YYYY-MM-DD"
}, _temp2);
exports.default = SaveTheDate;
module.exports = exports["default"];