"use strict";

exports.__esModule = true;
exports.parseDate = parseDate;
exports.withinRange = withinRange;
exports.daysOfMonth = daysOfMonth;

var _dateFns = require("date-fns");

function parseDate(date, fmt) {
  var parsed = (0, _dateFns.parse)(date);

  if (!(0, _dateFns.isValid)(parsed) || (0, _dateFns.format)(parsed, fmt) !== date) {
    return null;
  }

  return parsed;
}

function withinRange(date, _ref) {
  var start = _ref.start,
      end = _ref.end;

  if (start === null) {
    if (end === null) {
      return true;
    } else {
      return (0, _dateFns.isBefore)(date, end);
    }
  } else {
    if (end === null) {
      return (0, _dateFns.isAfter)(date, start);
    } else {
      return (0, _dateFns.isWithinRange)(date, start, end);
    }
  }
}

function daysOfMonth(date) {
  return (0, _dateFns.eachDay)((0, _dateFns.startOfWeek)((0, _dateFns.startOfMonth)(date)), (0, _dateFns.lastDayOfWeek)((0, _dateFns.lastDayOfMonth)(date)));
}